"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mcproto_1 = require("mcproto");
exports.getStatus = (host, port, checkPing = true) => __awaiter(this, void 0, void 0, function* () {
    const client = yield mcproto_1.Client.connect(host, port);
    client.send(new mcproto_1.PacketWriter(0x0).writeVarInt(404)
        .writeString(host).writeUInt16(client.socket.remotePort).writeVarInt(1));
    client.send(new mcproto_1.PacketWriter(0x0));
    const status = (yield client.nextPacket()).readJSON();
    if (checkPing) {
        client.send(new mcproto_1.PacketWriter(0x1).write(Buffer.alloc(8)));
        const start = Date.now();
        yield client.nextPacket(0x1);
        status.ping = Date.now() - start;
    }
    client.end();
    return status;
});
